// All variables, bits, and hardware ports are defined here
// For the Digital Wattmeter PCB version 1.3 OZ2CPU

 unsigned char   LCDPORT @ 0x75;
 unsigned char   sera;
 unsigned char   serb;
 unsigned char   user1;
 unsigned char   user2;
 unsigned char   user3;
 unsigned char   user4;
 unsigned char   user5;
 unsigned char   wpref;
 unsigned char   wpointer;
 unsigned char   w2;
 unsigned char   w1;
 unsigned char   wpoint;
 unsigned char   vpref;     // prefix u m v kv
 unsigned char   vpointer;  // pointer to array
 unsigned char   v2;       // decimal part
 unsigned char   v1;       // msb part
 unsigned char   vpoint;  // where to place decimal point
 unsigned char   del0;              
 unsigned char   del1;              
 unsigned char   del2;            
 unsigned char   DELAYTIME; 
 unsigned char   x;
 unsigned int    iuser1;
 unsigned int    peak;
 unsigned int    rfraw;
 unsigned int    rfrawB;
 unsigned int    rfraw2;  // compensated with calibration value
 unsigned int    rfRawAtt; // compensated and with att values
 unsigned int    rfdbm;
 unsigned char   dbswr;  // db value used for the return loss to SWR calculation
 unsigned int    voltraw;
 unsigned int    voltmax;
 unsigned int    voltmin;
 unsigned int    konv;
 unsigned int    LFcal;
 unsigned int    HFcal;
 unsigned int    VHFcal;
 unsigned int    UHFcal;
 unsigned int    SHFcal;
 unsigned int    ActualCal; // selected CAL value in this var
 unsigned int    RelativeCal;  // the zero value when entering Relative mode
 unsigned char   message1;  // to center of display
 unsigned char   message2;
 unsigned char   message3;
 unsigned char   messagenumber;
 unsigned char   messagetimer;
 unsigned char   messagetype;
 unsigned char   bandmode;  // in what freq band selected
 unsigned char   attmode; 
 unsigned char   menutype;
 unsigned char   displaydelay;  // sets the screen delay in mS
 unsigned char   peakholddelay; // for the SSB power screen
 unsigned char   metertype;     // RF, SSB, DC, RTN, ABOUT osv...


///////////////////////// bitfield :Flags  ///////////////////////////////
 
  bit	ENA    @ (unsigned)&PORTC*8+3 ;  // LCD controll BIT in PORTC
  bit	RW     @ (unsigned)&PORTC*8+2 ;
  bit	RS     @ (unsigned)&PORTC*8+0 ;

  bit	LC0       @ (unsigned)&LCDPORT*8+0 ;
  bit	LC1       @ (unsigned)&LCDPORT*8+1 ;
  bit	LC2       @ (unsigned)&LCDPORT*8+2 ;
  bit	LC3       @ (unsigned)&LCDPORT*8+3 ;
  bit	LC4       @ (unsigned)&LCDPORT*8+4 ;
  bit	LC5       @ (unsigned)&LCDPORT*8+5 ;
  bit	LC6       @ (unsigned)&LCDPORT*8+6 ;
  bit	LC7       @ (unsigned)&LCDPORT*8+7 ;  // defined in variable

  bit	LCD0      @ (unsigned)&PORTC*8+1 ; // display actual bits defined
  bit	LCD1      @ (unsigned)&PORTB*8+4 ;
  bit	LCD2      @ (unsigned)&PORTB*8+3 ;
  bit	LCD3      @ (unsigned)&PORTB*8+2 ;
  bit	LCD4      @ (unsigned)&PORTB*8+1 ;
  bit	LCD5      @ (unsigned)&PORTC*8+4 ;
  bit	LCD6      @ (unsigned)&PORTC*8+5 ;
  bit	LCD7      @ (unsigned)&PORTC*8+7 ;

  bit	BSEL      @ (unsigned)&PORTB*8+7 ;
  bit	BMENU     @ (unsigned)&PORTB*8+6 ;
  bit	BA        @ (unsigned)&PORTB*8+5 ; // encoder A
  bit	BB        @ (unsigned)&PORTB*8+0 ; // encoder B

  bit	SLUT;    // to end a sub
  bit   MENU;
  bit   BARGLO;  // if bargraph is hi or lo side
  bit   DISPSPD;
  bit   oldpos;    // encoder A edge detector
  bit   oldmenu;   // menu button, edge detector
  bit   oldselect; // select button, edge detector
  bit   RELATIVE;  // if on, the rf volt and rf power will not be shown
  bit   SWRERROR;  

///////////////////////// GLOBAL CONSTANTS///////////////////////////////

  //                db   0   1   2   3   4   5   6   7
const char swrconv[] = {255,255,255,255,255,255,200,161,132,110,92,78,67,57,49,43,37,32,28,25,22,19,17,15,13,11,10,9,8,7,6,6,5,4,4,3,3,3,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0};

const char wten[] = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,7,7,7,7,7,7,8,8,8,8,8,9,9,9,9,10};
const char wdec[] = {0,2,5,7,10,12,15,17,20,23,26,29,32,35,38,41,45,48,51,55,58,62,66,70,74,78,82,86,91,95,0,4,9,14,19,24,29,34,40,45,51,57,63,69,75,82,88,95,2,9,16,24,31,39,47,55,63,72,80,89,98,7,17,27,37,47,57,68,79,90,1,13,25,37,50,62,75,89,3,17,31,46,61,76,92,8,24,41,59,76,94,13,32,51,71,91,12,33,55,77,0};

const char vten[] = {22,22,22,23,23,23,23,24,24,24,25,25,25,25,26,26,26,27,27,27,28,28,28,29,29,29,30,30,30,
 31,31,31,32,32,33,33,33,34,34,35,35,35,36,36,37,37,37,38,38,39,39,40,40,41,41,42,42,43,43,44,44,45,
 45,46,46,47,47,48,48,49,50,50,51,51,52,53,53,54,54,55,56,56,57,58,58,59,60,60,61,62,63,63,64,65,65,
 66,67,68,69,69,70,71,72,73,74,74,75,76,77,78,79,80,81,82,83,84,85,85,86,88,89,90,91,92,93,94,95,96,
 97,98,99,101,102,103,104,105,107,108,109,110,112,113,114,116,117,118,120,121,122,124,125,127,128,130,
 131,133,134,136,137,139,141,142,144,146,147,149,151,152,154,156,158,160,161,163,165,167,169,171,173,
 175,177,179,181,183,185,188,190,192,194,197,199,201,203,206,208,211,213,216,218,221,223};

const char vdec[] = {36,62,88,15,41,69,96,24,52,80,9,38,67,97,27,58,88,19,51,83,15,48,81,14,48,82,16,
 51,87,22,59,95,32,70,7,46,84,24,63,3,44,85,26,68,11,54,97,41,86,31,76,22,69,16,64,12,61,10,60,10,62,
 13,65,18,72,26,81,36,92,49,6,64,23,82,42,3,64,26,89,52,17,82,48,14,81,50,18,88,59,30,2,75,49,24,99,
 76,53,31,10,90,71,53,36,20,4,90,77,65,53,43,34,26,19,13,8,4,1,100,99,0,2,5,9,15,21,29,39,49,61,74,88,
 4,21,39,59,80,2,26,52,79,7,37,68,1,35,71,8,47,88,30,74,20,67,16,67,19,74,30,87,47,9,72,37,4,74,45,18,
 93,70,49,30,13,99,86,76,68,62,59,57,58,62,67,75,86,99,14,32,52,75,1,29,60,93,29,68,10,54,2,52,5,61};


#define FALSE	            0
#define TRUE                1
#define OFF	            0
#define ON                  1
#define DISABLE	            0
#define ENABLE	            1
#define SET	            1

// Constants settings for metertype
#define ABOUT               0
#define DC                  2
#define SSB                 3
#define RF                  4
#define RTN                 5

// Contants settings for LCD goto
#define LINE1               0x80
#define LINE2               0xA9
#define CLEAR               0x01
#define GFXSET              0x40


///////////////// Defining MACROES

#define NOP() asm("nop");                         // Defining a compatibel nop
            

