void INIThardware()
{
  TRISB = 0b11100001;  // DISP DATA OUTPUT
  TRISC = 0b00000000; 
  PORTC = 0b01000000;  // TX = 1
  RBPU = 0;  // port B pull up
  // INIT ADC
  ADCON1 = 0b11100010;    // 10 bit convert ADRESH,ADRESL, PORTA=Analog VCC=REF (PORTE=Digital)
  ADCON0 = 0b01000001;    // 8T clock, Analog input RA0, adon
  PCFG3 = 0;
  PCFG2 = 1;
  PCFG1 = 0;
  PCFG0 = 1;  // AN3 is Vref AN0 and AN1 analog rest digital
  CHS2 = 0; CHS1 = 0;
  CHS0 = 1;  // Select AN1 input RF Level 
  CLRWDT();

 // get cal settings from EEPROM !!!
  user1 = eeprom_read(0);  // get first cal
  if ((user1==0)||(user1==255))  // check if data is bad
  {  
    eeprom_write(0,66);  // erase to normal harware cal 666
    Delay(20);
    eeprom_write(1,66);  // erase to normal harware cal 666
    Delay(20);
    eeprom_write(2,68);  // erase to normal harware cal 668
    Delay(20);
    eeprom_write(3,64);  // erase to normal harware cal 664
    Delay(20);
    eeprom_write(4,62);  // erase to normal harware cal 662
    Delay(20);
    eeprom_write(10,50);  // erase to normal harware cal 50mS  displaydelay
    Delay(20);
    eeprom_write(11,0);  // erase to 0 dB attenuator
    Delay(20);
  }
  user1 = eeprom_read(0);  // get value from EEPROM byte size
  LFcal = 600 + user1;     // Add 600 to the byte from EEPROM
  user1 = eeprom_read(1);  // 600 was subtracted, before saving value in EEPROM
  HFcal = 600 + user1;
  user1 = eeprom_read(2);
  VHFcal = 600 + user1;
  user1 = eeprom_read(3);
  UHFcal = 600 + user1;
  user1 = eeprom_read(4);
  SHFcal = 600 + user1;
  displaydelay = eeprom_read(10);  // get value from EEPROM
  attmode = eeprom_read(11);
  Ser1(' '); Ser1(' '); Ser1(10); Ser1(13);
  Ser1('O'); Ser1('Z'); Ser1('2'); Ser1('C'); Ser1('P'); Ser1('U');
  Ser1(' '); Ser1('d'); Ser1('w'); Ser1('m'); Ser1('1'); Ser1('0'); Ser1('3');
  Ser1(10); Ser1(13);
  konv = LFcal;
  KONVERTER();
  Ser1(user2); Ser1(user3); Ser1(user4); Ser1('-');
  konv = HFcal;
  KONVERTER();
  Ser1(user2); Ser1(user3); Ser1(user4); Ser1('-');
  konv = VHFcal;
  KONVERTER();
  Ser1(user2); Ser1(user3); Ser1(user4); Ser1('-');
  konv = UHFcal;
  KONVERTER();
  Ser1(user2); Ser1(user3); Ser1(user4); Ser1('-');
  konv = SHFcal;
  KONVERTER();
  Ser1(user2); Ser1(user3); Ser1(user4);
  Ser1(10); Ser1(13);
}

void InitVars()
{
  message1 = ' ';
  message2 = ' ';
  message3 = ' ';
  ActualCal = 666;
  bandmode = 0;   // LF
  messagenumber = 0;
  messagetimer = 0;
  messagetype = 0;
  oldmenu = 1;  // at powerup no menu
  metertype = RF;
  RELATIVE = 0;
  MENU = 0;
}

