//----------------------------------------------
//Compiler    : Hi-Tech  V7.86 PL3
//File        : Milli Watt Meter
//Edition     : Jan 2002 OZ2CPU (Ver 1.03)
//CPU         : PIC16F876 @ 4Mhz
//HardwareInfo: AD8307 -60 to +30dBm 
//Powertip PC2002-B  LCD 20 * 2 lines
//RB7=Select  RB5=A Encoder RB0=B Encoder  RB6=MENU
//AN1=DBM input  AN0=DC Voltmeter input  AN3=2.5Vref input
//More info and latest updated version at www.webx.dk
//Copyright note: not for sale or any commercial use,
//ONLY ELEKTOR MAGAZINE and OZ2CPU may sell programmed PIC's
//ONLY ELEKTOR MAGAZINE have special rights to put this source code set online
//ELEKTOR and OZ2CPU gives no support and no warranties on this source code,
//use it for study and learn how to programm a PIC using C
//---------------------------------------------------------------
#include <pic.h>     // to compiler, enter PIC mode.
#include "def.h"     // Define vars, constants and macros
#include "txt.h"     // some text for Help and About screens
#include "konv.c"    // konvert from integer to ascii
#include "serial.c"  // Software serial transmit routines
#include "delays.c"  // delay routines
#include "lcd.c"     // routiner to controll most standard LCD modules
#include "adc.c"     // all about the Analog to Digital converter
#include "subs.c"    // Here is alot varius routines
#include "info.c"    // help and about text screens
#include "measure.c" // all measure and display routines
#include "init.c"    // hardware and vars

__CONFIG(CP1|CP0|WRT|CPD|WDTE|FOSC0|BODEN);  // settings to HEX file
__IDLOC(103);  // Identify Locations 


void main(void)
{ 
  INIThardware();  // setup PIC and ports
  LCDinit();
  Welcome();
  LCDsetgfx();  // gfx for the bar-graf
  InitVars();  // also Get vars from EEPROM
  DISPSPD = 0;
  for(;;)  // loop evigt
  {
    GetADC();  // gets all 3 AD inputs and store the values in 3 vars.
    EncoderActions();
    LCDgoto(LINE1);
    EncoderActions();

    if (MENU) MenuActions();  // menu is a higher priority and it controlled by a BIT
    else
    if (metertype==SSB) WriteSSBmeter();
    else
    if (metertype==RF) WriteRFmeter();
    else
    if (metertype==DC) WriteDCmeter();
    else
    if (metertype==RTN) WriteRTNmeter();
    else
    if (metertype==ABOUT) WriteAbout();


    user1 = displaydelay;  // screen update delay
    while (user1>=1)
    {  
      EncoderActions();
      DelaymS(1);
      user1--;
    }
    EncoderActions();
    MessageUpdate();
  }  // end loopen
}    // end main 

