// software serial sender is made in assembler to make timing exact
// 4.00 Mhz PIC clock gives 38400 Baud
// software serial sender is needed due to the hardware programming facilities
// in the PIC that uses 2 pins (RX and TX) if the hardware serial module is
// selected, the PCB was wired to the LCD, and only the TX pin was reserved
// long time before the serial out was made...
// By OZ2CPU 2001, 2002 and beyond.

void Ser1(user1)
{
  LCDPORT = user1;
  NOP();
  #asm
  bcf  3,5        ; select right ram bank
  bcf  3,6
  goto Serstart
  SerSpeed  // this sub generate the 26uS bit speed for 38400 Baud
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop
  nop 
  nop
  nop
  nop
  nop
  nop
  nop
  return
  Serstart
  bcf  7,6        ; RC6=0;  // startbit
  nop
  nop
  call SerSpeed
  btfss  117,0    ; check LC0     1   1
  goto  ser00     ; if zero jump  2   1
  nop             ;                   1
  bsf  7,6        ; RC6 = 1           1*
  goto  ser01     ;                   2
  ser00:
  bcf  7,6        ; RC6 = 0;      1*
  nop             ;               1
  nop             ;               1
  ser01:
  call SerSpeed
  btfss  117,1    ; check LC1
  goto  ser10     ; if zero jump
  nop
  bsf  7,6        ; RC6 = 1
  goto  ser11
  ser10:
  bcf  7,6        ; RC6 = 0;
  nop
  nop
  ser11:
  call SerSpeed
  btfss  117,2    ; check LC2
  goto  ser20     ; if zero jump
  nop
  bsf  7,6        ; RC6 = 1
  goto  ser21
  ser20:
  bcf  7,6        ; RC6 = 0;
  nop
  nop
  ser21:
  call SerSpeed
  btfss  117,3    ; check LC3
  goto  ser30     ; if zero jump
  nop
  bsf  7,6        ; RC6 = 1
  goto  ser31
  ser30:
  bcf  7,6        ; RC6 = 0;
  nop
  nop
  ser31:
  call SerSpeed
  btfss  117,4    ; check LC4
  goto  ser40     ; if zero jump
  nop
  bsf  7,6        ; RC6 = 1
  goto  ser41
  ser40:
  bcf  7,6        ; RC6 = 0;
  nop
  nop
  ser41:
  call SerSpeed
  btfss  117,5    ; check LC5
  goto  ser50     ; if zero jump
  nop
  bsf  7,6        ; RC6 = 1
  goto  ser51
  ser50:
  bcf  7,6        ; RC6 = 0;
  nop
  nop
  ser51:
  call SerSpeed
  btfss  117,6    ; check LC6
  goto  ser60     ; if zero jump
  nop
  bsf  7,6        ; RC6 = 1
  goto  ser61
  ser60:
  bcf  7,6        ; RC6 = 0;
  nop
  nop
  ser61:
  call SerSpeed
  btfss  117,7    ; check LC7
  goto  ser70     ; if zero jump
  nop
  bsf  7,6        ; RC6 = 1
  goto  ser71
  ser70:
  bcf  7,6        ; RC6 = 0;
  nop
  nop
  ser71:
  call SerSpeed
  nop
  nop
  nop
  bsf  7,6        ; RC6 = 1  stopbit
  call SerSpeed
  #endasm
}
